/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// Rendu de monnaie avec une stratégie gloutonne


#include "prelude.h"
#include "greedy_change.h"

void print(int n, int coins[], int v, int change[]) {
  printf("Somme à rendre\t-> %d\n", v);
  for (int i = 0; i < n; i++) {
    printf("%d\t-> %d\n", coins[i], change[i]);
  }
}

void greedy_change(int n, int coins[], int v, int change[]) {
  int cur = v;
  int i = n-1;
  while (cur > 0) {
    if (cur < coins[i]) { i--; }
    else {
      change[i]++;
      cur = cur - coins[i];
    }
  }
}

int main(int argc, char **argv) {
  // valeurs exemples du livre
  int v = 49;
  int n = 8;
  int coins[] = {1, 2, 5, 10, 20, 50, 100, 200};
  int *change = calloc(n, sizeof(int));
  
  greedy_change(n, coins, v, change);
  print(n, coins, v, change);

  free(change);
}
